#include "MIDIUSB.h"
#include <Keypad.h>


const byte ROWS = 5; //four rows
const byte COLS = 5; //three columns
char keys[ROWS][COLS] = {{60,65,70,75,80}, 
                         {61,66,71,76,81}, 
                         {62,67,72,77,82}, 
                         {63,68,73,78,83},
                         {64,69,74,79,84}};
                         
byte rowPins[ROWS] = {7,8,9,10,16}; //connect to the row pinouts of the kpd
byte colPins[COLS] = {2,3,4,5,6}; //connect to the column pinouts of the kpd

Keypad kpd = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );

unsigned long loopCount;
unsigned long startTime;
String msg;


void setup() {
     
  //Serial.begin(9600);
    loopCount = 0;
    startTime = millis();
    msg = "";
}


void loop() {
  
    loopCount++;
    if ( (millis()-startTime)>5000 ) {
        //Serial.print("Average loops per second = ");
        //Serial.println(loopCount/5);
        startTime = millis();
        loopCount = 0;
    }

    // Fills kpd.key[ ] array with up-to 10 active keys.
    // Returns true if there are ANY active keys.
    if (kpd.getKeys())
    {
        for (int i=0; i<LIST_MAX; i++)   // Scan the whole key list.
        {
            if ( kpd.key[i].stateChanged )   // Only find keys that have changed state.
            {
                int keis = kpd.key[i].kchar;
                switch (kpd.key[i].kstate) {  // Report active key state : IDLE, PRESSED, HOLD, or RELEASED
                    case PRESSED:
                    
                   //Serial.write(keis);
                    noteOn(1,keis,127);
                    MidiUSB.flush();
                    // Send note 42 with velocity 127 on channel 1
                   // MIDI.sendNoteOn(keis, 127, 1);
                    
                    // Read incoming messages
                    //MIDI.read();
                break;
                    case HOLD:
                    
                break;
                    case RELEASED:
                    
                    noteOff(1,keis,127);
                    //MIDI.sendNoteOff(keis, 127, 1);
                    MidiUSB.flush();
                break;
                    case IDLE:
                    break;
                }  
            }
        }
    }
}  // End loop

// Arduino MIDI functions MIDIUSB Library
void noteOn(byte channel, byte pitch, byte velocity) {
  midiEventPacket_t noteOn = {0x09, 0x90 | channel, pitch, velocity};
  MidiUSB.sendMIDI(noteOn);
}

void noteOff(byte channel, byte pitch, byte velocity) {
  midiEventPacket_t noteOff = {0x08, 0x80 | channel, pitch, velocity};
  MidiUSB.sendMIDI(noteOff);
}
